
from sys import argv
from ldasPre import *
import myPyFunc as my
plt = my.plt

argv = ['','options_Spain.py','init']
try: execfile('ldasPost.py')
except SystemExit: pass


zname = 'model zone'
zone = post_zones[zname]

map_set,graphics_dir_zone,IPNT = prepareZone(zname,zone,map_set,graphics_dir)
mod_lon,mod_lat = res2lonlat(mod_grid['res'],mod_grid['zone'])
trip_lon,trip_lat = res2lonlat(trip_grid['res'],trip_grid['zone'])


grid_transf_info = {'method':'upscale_average','parameters':{'half_pix':mod_grid['res']*0.5,'min_obs':1}}

print('Lookup')
trip_lookup,_ = getLookups(trip_grid,mod_grid,mod_lon,mod_lat,grid_transf_info)

print('Apply lookup')
trip_mask,_ = applyLookup(trip_lookup,IPNT,1)

mod_mask = pl.array(IPNT,dtype='int').reshape((len(mod_lat),len(mod_lon)))
trip_mask = trip_mask.reshape((len(trip_lat),len(trip_lon)))



plt.ion()

plt.figure(1); plt.clf()
my.pmap(mod_lon,mod_lat,mod_mask,MV=0)

plt.figure(2); plt.clf()
my.pmap(trip_lon,trip_lat,trip_mask,MV=0)

my.link_axes()

