
import pylab as pl
import pickletools as pkt
import pandas as pd
from sys import exit
import myPyFunc as my

#fname = '/cnrm/vegeo/munier/e2o/GLO_1D/results/eco_lai/eco/LAI_06_evergreen_2004-01-01_2004-12-31.PData'
#fname = '/cnrm/vegeo/munier/e2o/GLO_1D/results/eco_lai/eco/LAI_2000-01-01_2000-12-31.PData'
#fname = '/cnrm/vegeo/munier/e2o/GLO_1D/observations/sfx-trip/LAI_2000-01-01_2000-12-31.PData'
#fname = '/home/muniers/LDAS/Spain/observations/sfx-trip/SSM_2009-01-01_2009-12-31.PData'
#fname = '/home/muniers/LDAS/Spain/observations/sfx-trip_tmp2/LAI_2009-01-01_2009-12-31.PData'
fname = '/cnrm/vegeo/munier/e2o/Spain/results/sfx-trip/ldas_post/lai_til_interp_tr99/LAI_07_c3_2009-01-01_2009-12-31.PData'

fid = open(fname,'rb')
global inc
inc = 0
memo = dict()

close_mark = ['APPENDS','LIST','TUPLE','DICT','SETITEMS','POP_MARK','OBJ']
if True:
  inc = 0
  for o,a,p in pkt.genops(fid):
      if o.name in close_mark: inc = inc-1
      print('{:10d} '.format(p)+('  ')*inc+'{:4s} {:15s}'.format(o.code,o.name)),
      if o.code!='T': print(a)
      else: print('')
      if o.name=='MARK': inc = inc+1
  exit()


def memmapVariable(fid,var,memo):
#var = 'DatetimeIndex'
#if True:
  global inc
  found_var_def = False
  found_binstring = False
  found_mark = False
  found_shp = False
  found_fmt = False
  found_endian = False
  found_variable = False
  shp = []
  add_ns = ''
  order = 'F'
  while not found_variable:
    o,a,p = pkt.genops(fid).next()
    if True:
      print('{:10d} '.format(p)+('  ')*inc+'{:4s} {:15s}'.format(o.code,o.name)),
      if o.code!='T': print(a)
      else: print('')
      if o.name=='MARK': inc = inc+1
      if o.name in close_mark: inc = inc-1
    if o.name=='GLOBAL':
      pos = fid.tell()
      o1,a1,p1 = pkt.genops(fid).next()
      if o1.name=='BINPUT': memo[a1] = a
      fid.seek(pos)
    if not found_var_def:
      if o.name=='GLOBAL' and var in a: found_var_def = True
      elif o.name=='BINGET' and a in memo.keys() and var in memo[a]: found_var_def = True
    elif not found_binstring:
      if o.name=='SHORT_BINSTRING' and a=='b': found_binstring = True
    elif not found_mark:
      if o.name=='MARK': found_mark = True
    elif not found_shp:
      if o.name[:6]=='BININT': shp.append(a)
      if 'TUPLE' in o.name: shp,found_shp = shp[-int(o.name[5:]):],True
    elif not found_fmt:
      if 'SHORT_BINSTRING' in o.name: fmt,found_fmt = a,True
    elif not found_endian:
      if o.name=='SHORT_BINSTRING': endian,found_endian = a,True
    elif o.name=='SHORT_BINSTRING' and 'ns' in a: add_ns = '[ns]'
    else:
      if o.name == 'NEWTRUE': order = 'C'
      if fid.read(1)=='T': found_variable = True
      fid.seek(-1,1)
    #print(found_var_def,found_binstring,found_mark,found_shp,found_fmt,found_endian,found_endian,found_variable)
  offset = fid.tell()+5
  while 1 in shp: shp.remove(1)
  values = pl.memmap(fname,endian+fmt+add_ns,mode='r',offset=offset,shape=tuple(shp[::-1]),order=order)
  fid.seek(5+pl.dtype(endian+fmt+add_ns).itemsize*reduce(lambda x, y: x*y, shp),1)
  return values
  
dat = memmapVariable(fid,'DatetimeIndex',memo)
val = memmapVariable(fid,'numpy ndarray',memo)

fid.close()

ptmp = pd.read_pickle(fname)
dat0 = ptmp.index
val0 = ptmp.values

print(my.ran(val-val0))


